.486
.model flat, stdcall

option 	casemap: none

include 	\masm32\include\windows.inc
include 	\masm32\include\user32.inc
include 	\masm32\include\kernel32.inc
include 	\masm32\include\masm32.inc
include		combine.inc
includelib 	\masm32\lib\kernel32.lib
includelib 	\masm32\lib\user32.lib
includelib 	\masm32\lib\masm32.lib
AddToReadBuffer	PROTO	STDCALL :DWORD, :DWORD
ProcessReadBuffer	PROTO	STDCALL
TranslateLine	PROTO	STDCALL :DWORD, :DWORD
GetCombineINI	PROTO	STDCALL
CloseFiles		PROTO	STDCALL
ResolveLine		PROTO	STDCALL :DWORD
GetFileFromID	PROTO	STDCALL :DWORD
.data
	MasmCommand			db		"ml ",0
	MasmErrorText		db	") : error ",0
	MasmFErrorText		db	") : fatal error ",0
	
	
	;--- INI file data ---
	INISectionFiles		db	"Files",0
	INIKeyLineInfo		db	"LineInfo",0
	DefaultString		db	"N/A!",0
	ErrNoINI			db	"ERROR: Could not open combine.ini.",0dh,0ah
	ErrNoINIlen 		equ	$-ErrNoINI
	ErrNoLIF			db	"ERROR: No line information file in combine.ini or combine.ini not found.",0dh,0ah
	ErrNoLIFlen			equ	$-ErrNoLIF
	ErrLIFFailed		db	"ERROR: Failed to open the line information file.",0dh,0ah
	ErrLIFFailedlen		equ	$-ErrLIFFailed
	ErrLIFMap			db	"ERROR: Failed to create file mapping.",0dh,0ah
	ErrLIFMaplen		equ	$-ErrLIFMap	
	ErrInvalidLIF		db	"ERROR: Invalid line information file.",0dh,0ah
	ErrInvalidLIFlen	equ	$-ErrInvalidLIF
.data?
 	;--- Module handle ---
	hInstance			dd		?
	
	;--- Standard handles ---
	STDError			dd		?
	STDOutput			dd		?
	STDInput			dd		?

	;--- File function data ---
	BytesWritten		dd		?
	BytesRead			dd		?
	;hLineInfoFile		dd		?				;line info file handle
	buffer1				db		256 dup  (?)
	buffer2				db		260 dup  (?)
	
	INIFileName			db		260 dup (?)
	
	;--- source file handle table ---
	NrOfFiles			dd		?
	hLIF				dd		? ;handle of line info file
	hLIFMap				dd		?
	pLIFMap				dd		?
	pLIFMapEnd			dd		?
	lpLineData			dd		?
	;--- pipe info ---
	SInfo				STARTUPINFO <?>
	PInfo				PROCESS_INFORMATION <?>
	SecAttr				SECURITY_ATTRIBUTES <?>
	hPipeRead			dd		?
	hPipeWrite			dd		?

	;--- read buffer data ---
	MAX_READBUFFERSIZE	equ		1020
	ReadBuffer			db		MAX_READBUFFERSIZE+4 dup (?) ;+4 for safety reasons
	OutputBuffer		db		MAX_READBUFFERSIZE+4 dup (?) ;+4 for safety reasons
	BufferBytesUsed		dd		?
	
	
	;--- Line info file data ---
	;LIFStdHeader			LINEINFOFILE_HEADER <?>
	
.code
start:
;------------------------------------------------------------------------------------------
; Initialize
;------------------------------------------------------------------------------------------
	invoke 	GetModuleHandle, NULL
	mov		hInstance, eax
	
;------------------------------------------------------------------------------------------
; Get Standard Handles
;------------------------------------------------------------------------------------------
	mov 	hInstance, eax
    invoke	GetStdHandle, STD_ERROR_HANDLE
	mov		STDError, eax
	invoke	GetStdHandle, STD_OUTPUT_HANDLE
	mov		STDOutput, eax
	invoke	GetStdHandle, STD_INPUT_HANDLE
	mov		STDInput, eax



	invoke	GetCombineINI

	mov 	SecAttr.nLength, SIZEOF SECURITY_ATTRIBUTES
	mov 	SecAttr.lpSecurityDescriptor,NULL
	mov 	SecAttr.bInheritHandle,TRUE
	invoke 	CreatePipe, ADDR hPipeRead, ADDR hPipeWrite, ADDR SecAttr, NULL
	.IF		eax==NULL
		;error handler
	.ENDIF
	mov		SInfo.cb, SIZEOF STARTUPINFO
	invoke	GetStartupInfo, ADDR SInfo
	mov		eax, hPipeWrite
	mov 	SInfo.hStdOutput,eax
	mov 	SInfo.hStdError,eax
	mov 	SInfo.dwFlags, STARTF_USESHOWWINDOW OR STARTF_USESTDHANDLES
	mov 	SInfo.wShowWindow, SW_HIDE
	
	invoke	GetCommandLine
	invoke	lstrcpy, ADDR buffer1, eax
	mov		ecx, offset buffer1
	.IF		byte ptr [ecx]=='"';
		inc		ecx
		.WHILE	1
			mov		al, [ecx]
			.IF		al==0
				jmp		@err_cl
			.ELSEIF al=='"'
				inc		ecx
				.BREAK
			.ENDIF
		inc	ecx
		.ENDW
	.ELSE
		.WHILE	1
			mov		al, [ecx]
			.IF		al==" " 
				inc		ecx
				.BREAK
			.ELSEIF al==0
				.BREAK
			.ENDIF
			inc		ecx
		.ENDW
	.ENDIF
	invoke	lstrcpy, ADDR buffer2, ADDR MasmCommand
	invoke	lstrcat, ADDR buffer2, ecx
	invoke 	CreateProcess, NULL, ADDR buffer2,\
			NULL, NULL, TRUE, NULL, NULL, NULL, \
			ADDR SInfo, ADDR PInfo
	.IF		eax==NULL
		;errhandler
	.ELSE
		invoke	CloseHandle, hPipeWrite
		.WHILE	1
			;invoke RtlZeroMemory,addr buffer1,256
			invoke ReadFile, hPipeRead, ADDR buffer1, 256, ADDR BytesRead, NULL
			.IF eax==NULL
				.BREAK
			.ELSE
				invoke	AddToReadBuffer, ADDR buffer1, BytesRead
				.IF		eax!=NULL	;no buffer overflow?
					invoke	ProcessReadBuffer
				.ENDIF
					
					
				;invoke	WriteFile, STDOutput, ADDR buffer1, BytesRead, ADDR BytesWritten, NULL
				
				;handle buffer
			.ENDIF
		.ENDW
	.ENDIF
	invoke CloseHandle, hPipeRead


;	invoke MessageBox,hWnd,addr CreateProcessError,addr AppName,MB_ICONERROR+MB_OK
;	.else
;	invoke CloseHandle,hWrite
;	.while TRUE
;	invoke RtlZeroMemory,addr buffer,1024
;	invoke ReadFile,hRead,addr buffer,1023,addr bytesRead,NULL
;	.if eax==NULL
;	.break
;	.else
;								invoke SendMessage,hwndEdit,EM_SETSEL,-1,0
;								invoke SendMessage,hwndEdit,EM_REPLACESEL,FALSE,addr buffer
;							.endif
;						.endw
;					.endif
;					invoke CloseHandle,hRead
;	
	invoke	CloseFiles
	invoke	ExitProcess, 0
@err_cl:
	invoke	CloseFiles
	invoke	ExitProcess, 1

ProcessReadBuffer 	proc uses edx ecx esi ebx
xor esi, esi
@ub_trymore:
    mov edx, offset ReadBuffer 
    mov ecx, edx
    add ecx, BufferBytesUsed
;---------- Scan for CR/LF------------
    .WHILE (edx<ecx)
        mov bl, byte ptr [edx]
        .IF bl==0Dh
            mov bl,byte ptr [edx+1]
            .IF bl==0Ah
                inc edx
            .ENDIF
            inc edx
            jmp @found1
        .ELSEIF bl==0Ah
            inc edx
            jmp @found1
        .ENDIF
        inc edx
    .ENDW
    jmp @not_found
@found1:
    inc esi
    push edx
    push ecx
    ; ReceivedData contains the next full line received, NOT 0-terminated, but edx 
    ; now points to the end of the line, including CR/LF/CRLF 
    invoke	TranslateLine, ADDR ReadBuffer, edx
    invoke	WriteFile, STDOutput, ADDR OutputBuffer, eax, ADDR BytesWritten, 0
    pop ecx
    pop edx
    ; --- now the line is deleted and the data after the line is shift back ---
    mov ebx, ecx
    sub ebx, edx
    ; ebx = nr of bytes 2 copy
    mov BufferBytesUsed,ebx
    mov ecx, offset ReadBuffer
    mov eax, edx
    add eax, ebx
    .WHILE ecx<eax
        mov bl, byte ptr [edx]
        mov byte ptr [ecx], bl
        inc ecx
        inc edx
    .ENDW
    jmp @ub_trymore
@not_found:
    mov eax, esi
ret
ProcessReadBuffer	endp


TranslateLine	proc uses ebx esi lpLine:DWORD, lpEnd:DWORD
	mov		ecx, lpEnd
	mov		al, byte ptr [ecx]
	push	eax
	mov		byte ptr [ecx], 0
	;--- line at lpLine is now 0-terminated ---
	; example:   combine.asm(108) : error A2044: invalid character in file
	invoke	InString, 1, lpLine, ADDR MasmErrorText
	or		eax, eax
	jle		@aa
		jmp		@founderror
	@aa:
	invoke	InString, 1, lpLine, ADDR MasmFErrorText
	or		eax, eax
	jle		@bb
		jmp		@founderror
	@bb:
	pop		eax
	mov		ecx, lpEnd
	mov		byte ptr [ecx], al
	mov		ebx, lpEnd
	sub		ebx, lpLine
	invoke	MemCopy, lpLine, ADDR OutputBuffer, ebx
	mov		eax, ebx ;returns number of bytes to output
	ret
@founderror:
	
	dec		eax
	add		eax, lpLine
	mov		ebx, eax
	; ebx points to ) after error number
	
	mov		esi, eax
	.WHILE	1
		dec		esi
		.IF		byte ptr [esi]=="("
			inc		esi
			.BREAK
		.ENDIF
	.ENDW
	invoke	RtlZeroMemory, ADDR OutputBuffer, MAX_READBUFFERSIZE
	
	;mov		eax, esi
	;sub		eax, lpLine
	;dec		eax
	mov		eax, ebx
	sub		eax, esi	
	invoke	MemCopy, esi, ADDR OutputBuffer, eax
	;---outputbuffer now contains error line number in ascii---
	invoke	atodw, ADDR OutputBuffer

	;--- "file.asm(linenr" should now be outputted to outputbuffer---
	invoke	ResolveLine, eax
	push	ecx
	invoke	GetFileFromID, eax
	invoke	lstrcpy, ADDR OutputBuffer, eax
	invoke	lstrlen, ADDR OutputBuffer
	add		eax, offset OutputBuffer
	mov		byte ptr [eax], "("
	inc		eax
	pop		ecx
	invoke	dwtoa, ecx, eax
	
	

	
	;--- add old error message to new file name ---
	invoke	lstrcat, ADDR OutputBuffer, ebx
	
	; --- return nr of bytes to output ---
	invoke	lstrlen, ADDR OutputBuffer
	mov		ebx, eax
	pop		eax
	mov		ecx, lpEnd
	mov		byte ptr [ecx], al
	mov		eax, ebx ;returns number of bytes to output
ret
TranslateLine	endp

AddToReadBuffer	proc	lpData:DWORD, dwLen:DWORD
	mov		eax, BufferBytesUsed
	add		eax, dwLen
	.IF		eax>MAX_READBUFFERSIZE
		xor		eax, eax	;buffer overflow
		ret
	.ENDIF
	
	mov		ecx, offset ReadBuffer
	add		ecx, BufferBytesUsed
	mov		BufferBytesUsed, eax ;new size
	invoke	MemCopy, lpData, ecx, dwLen
ret
AddToReadBuffer	endp

;==========================================================================================
; Get combine.ini procedure
;==========================================================================================
GetCombineINI proc uses ecx ebx edx esi edi
LOCAL	bufferA[260]:BYTE
	; --- Construct path&name of combine.ini in current directory---
	invoke 	GetCurrentDirectory, 260, ADDR INIFileName
	mov		ecx, offset INIFileName
	add		ecx, eax
	.IF		byte ptr [ecx-1]!="\"
		mov		byte ptr [ecx],"\"
	.ENDIF
	inc		ecx
	mov 	dword ptr [ecx], "bmoc"
	mov 	dword ptr [ecx+4], ".eni"
	mov 	dword ptr [ecx+8], 00696e69h
	; --- combine.ini file is now in INIFileName ---
;------------------------------------------------------------------------------------------
; Get line number info file
;------------------------------------------------------------------------------------------		
	; --- Get destination filename from ini file in buffer1---
	invoke 	GetPrivateProfileString, ADDR INISectionFiles,ADDR INIKeyLineInfo,\
			 ADDR DefaultString, ADDR bufferA, 260, ADDR INIFileName	
	
	; --- get filename ---
	lea		eax, bufferA
	mov 	eax, [eax]
	
	; --- if not found, no line number info file is created ---
	.IF eax=="!A/N"
		invoke	WriteFile, STDError, ADDR ErrNoLIF, ErrNoLIFlen, \
		ADDR BytesRead, NULL
		jmp		@failed
	.ENDIF	
	
	invoke	CreateFile, ADDR bufferA, GENERIC_READ, FILE_SHARE_READ,\
			NULL, OPEN_EXISTING, NULL, NULL
	.IF		eax==INVALID_HANDLE_VALUE
		invoke	WriteFile, STDError, ADDR ErrLIFFailed, ErrLIFFailedlen, \
		ADDR BytesRead, NULL
		jmp		@failed
	.ENDIF
	mov		hLIF, eax
	invoke	CreateFileMapping, hLIF, NULL, PAGE_READONLY, 0, 0, 0
	.IF		eax==NULL
		invoke	WriteFile, STDError, ADDR ErrLIFMap, ErrLIFMaplen, \
		ADDR BytesRead, NULL
		jmp		@failed
	.ENDIF
	mov		hLIFMap, eax
	invoke	MapViewOfFile, eax, FILE_MAP_READ, 0, 0, 0
	.IF		eax==NULL
		invoke	WriteFile, STDError, ADDR ErrLIFMap, ErrLIFMaplen, \
		ADDR BytesRead, NULL
		jmp		@failed
	.ENDIF
	mov		pLIFMap, eax
	mov		pLIFMapEnd, eax
	invoke	GetFileSize, hLIF, 0
	.IF		eax<SIZEOF LINEINFOFILE_HEADER+2
		jmp		@invalid
	.ENDIF
	add		pLIFMapEnd, eax
	
	mov		ecx, pLIFMap
	assume	ecx:PTR LINEINFOFILE_HEADER	
	.IF		[ecx].dwMagic!=0046494Ch ;"LIF\0"
		jmp		@invalid
	.ENDIF
	push	[ecx].dwNrOfFiles
	pop		NrOfFiles
	push	[ecx].pLineData
	pop		lpLineData
	mov		eax, pLIFMap
	add		lpLineData, eax
	assume 	ecx:nothing
	
	xor		eax, eax
	inc		eax			;success
ret
@failed:
	invoke	CloseFiles
	xor		eax, eax
	ret
@invalid:
	.IF		eax==NULL
		invoke	WriteFile, STDError, ADDR ErrInvalidLIF, ErrInvalidLIFlen, \
		ADDR BytesRead, NULL
		jmp		@failed
	.ENDIF
	invoke	CloseFiles
	xor		eax, eax
ret
GetCombineINI endp 


; TWO RETURN VALUES: eax = file number (-1 if failed), ecx = line number
ResolveLine	proc	linenr:DWORD
	mov		ecx, lpLineData
	mov		edx, pLIFMapEnd
	.WHILE	ecx<edx
		mov		eax, [ecx]
		.IF		linenr>=eax
			add		ecx, 12
			.IF		ecx>=edx
				sub		ecx, 12
				jmp		@found
			.ELSE
				mov		eax, [ecx]
				.IF		linenr<eax
					sub		ecx, 12
					jmp		@found
				.ENDIF
			.ENDIF
			.CONTINUE
		.ENDIF
		add		ecx, 12
	.ENDW
	jmp		@error
@found:
	mov		eax, [ecx+4] ;eax = filenumber
	mov		edx, linenr
	sub		edx, [ecx]   ;sub main file number
	add		edx, [ecx+8] ;add sub file number
	mov		ecx, edx
ret
@error:
xor	eax, eax
dec	eax
ret
ResolveLine	endp
CloseFiles		proc
	.IF		hLIF!=0
		invoke	CloseHandle, hLIF
	.ENDIF
	.IF		pLIFMap!=0
		invoke	UnmapViewOfFile, pLIFMap
	.ENDIF
	.IF		hLIFMap!=0
		invoke	CloseHandle, hLIF
	.ENDIF
ret
CloseFiles		endp
GetFileFromID	proc	FileID:DWORD
	mov		ecx, pLIFMap
	add		ecx, SIZEOF LINEINFOFILE_HEADER
	xor		edx, edx
	.WHILE	edx!=FileID
		.WHILE 1
			mov	al,[ecx]
			.IF al==0
				inc ecx
				.BREAK
			.ENDIF
			inc ecx
		.ENDW
		inc	edx
	.ENDW
	mov		eax, ecx
ret
GetFileFromID	endp
end start