WndProc				PROTO STDCALL	:DWORD, :DWORD, :DWORD, :DWORD
.code
WndProc proc	hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
mov eax, uMsg
	.IF 	eax==WM_CREATE
		invoke		InitControls, hWnd
		invoke		InitBitmaps, hWnd
		invoke		InitGame, hWnd
		invoke		SetTimer, hWnd, ID_TIMER1, 500, NULL
	.ELSEIF eax==WM_COMMAND
		mov 	eax, wParam
		shr 	ax, 16
		.IF		ax==0 ; menu notification
			
			invoke	ProcessMenuItems, hWnd, wParam
		.ENDIF
	.ELSEIF eax==WM_LBUTTONDOWN
		mov		eax, lParam
		and		eax, 0ffffh
		mov		ecx, lParam
		shr		ecx, 16

		invoke	ChildWindowFromPoint, hWnd, eax,ecx
		.IF		eax==hStatic		; clicked in static window?
			invoke	ProcessClick, hWnd, lParam
		.ENDIF
	.ELSEIF eax==WM_TIMER
		mov		eax, wParam
		.IF		eax==ID_TIMER1
			invoke	UpdateInfo		
		.ENDIF
	.ELSEIF eax==WM_DRAWITEM
		mov		eax, wParam
		.IF		eax==CID_STATIC
			push	ebx
			mov		ebx, lParam
			assume	ebx:ptr DRAWITEMSTRUCT
			invoke	DrawProc, hWnd, [ebx].hdc
			assume	ebx:nothing
			pop		ebx
			xor		eax, eax
			inc		eax
		.ELSE
			xor 	eax, eax
		.ENDIF
	.ELSEIF	eax==WM_DESTROY
		invoke	KillTimer, hWnd, ID_TIMER1
		invoke	DeleteBitmaps
		invoke	PostQuitMessage, NULL
	.ELSE
		invoke 	DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF

ret
WndProc endp
